commit 25755954bef7be451290f6b74d480541ef4244d5
Author: Moritz Bunkus <m.bunkus@linet.de>
Date:   Tue Nov 8 13:04:14 2016 +0100

    Übersetzungen aktualisiert

diff --git a/SL/Controller/Inventory.pm b/SL/Controller/Inventory.pm
index 454b012e2..c56bb7826 100644
--- a/SL/Controller/Inventory.pm
+++ b/SL/Controller/Inventory.pm
@@ -101,7 +101,6 @@ sub action_usage {
                             warehouse_id bin_id partnumber description bestbefore chargenumber partstypes_id);
   my %column_defs = (
     'partnumber'      => { 'text' => $locale->text('Part Number'), },
- #   'partclass'       => { 'text' => $locale->text('Part Classification'), },
     'partdescription' => { 'text' => $locale->text('Part_br_Description'), },
     'unit'            => { 'text' => $locale->text('Unit'), },
     'stock'           => { 'text' => $locale->text('stock_br'), },
@@ -385,7 +384,6 @@ sub make_row_result {
        $row->{outcorrection}->{data} - $row->{incorrection}->{data};
   $row->{averconsumed}->{data} = $row->{consumed}->{data}*30/$days ;
   map { $row->{$_}->{data} = $form->format_amount($myconfig,$row->{$_}->{data},2); } $self->getnumcolumns();
-#  $row->{partclass}->{data} = '';
   $row->{partnumber}->{link} = 'ic.pl?action=edit&id='.$partid;
 #  $row->{partdescription}->{link} = 'ic.pl?action=edit&id='.$partid;
 }
diff --git a/locale/de/all b/locale/de/all
index 9347f38de..db133be9d 100755
--- a/locale/de/all
+++ b/locale/de/all
@@ -462,7 +462,6 @@ $self->{texts} = {
   'CB/OB Transactions'          => 'SB/EB buchen',
   'CR'                          => 'H',
   'CSS style for pictures'      => 'CSS Style für Bilder',
-  'CSV'                         => 'CSV',
   'CSV export -- options'       => 'CSV-Export -- Optionen',
   'CSV import: ar transactions' => 'CSV Import: Debitorenbuchungen',
   'CSV import: bank transactions' => 'CSV Import: Bankbewegungen',
@@ -1683,7 +1682,6 @@ $self->{texts} = {
   'MAILED'                      => 'Gesendet',
   'MD'                          => 'PT',
   'MIME type'                   => 'MIME-Typ',
-  'MT940'                       => 'MT940',
   'MT940 import'                => 'MT940 Import',
   'Main Preferences'            => 'Grundeinstellungen',
   'Main sorting'                => 'Hauptsortierung',
@@ -2008,13 +2006,12 @@ $self->{texts} = {
   'Part'                        => 'Ware',
   'Part "#1" has chargenumber or best before date set. So it cannot be transfered automatically.' => 'Bei Artikel "#1" ist eine Chargenummer oder ein Mindesthaltbarkeitsdatum vergeben. Deshalb kann dieser Artikel nicht automatisch ausgelagert werden.',
   'Part (database ID)'          => 'Artikel (Datenbank-ID)',
-  'Part Classification'         => '',
   'Part Description'            => 'Artikelbeschreibung',
   'Part Description missing!'   => 'Artikelbezeichnung fehlt!',
   'Part Notes'                  => 'Bemerkungen',
   'Part Number'                 => 'Artikelnummer',
   'Part Number missing!'        => 'Artikelnummer fehlt!',
-  'Part Unit'                   => '',
+  'Part Unit'                   => 'Artikeleinheit',
   'Part picker'                 => 'Artikelauswahl',
   'Part_br_Description'         => 'Beschreibung',
   'Partial invoices'            => 'Teilrechnungen',
@@ -3184,7 +3181,6 @@ $self->{texts} = {
   'This will set an exact price.' => 'Diese Option setzt einen festen Preis.',
   'Three Options:'              => 'Drei Optionen:',
   'Time Format'                 => 'Uhrzeitformat',
-  'Time Tracking'               => 'Zeiterfassung',
   'Time and price estimate'     => 'Zeit- und Preisschätzung',
   'Time estimate'               => 'Zeitschätzung',
   'Time period for the analysis:' => 'Analysezeitraum:',
@@ -3217,10 +3213,8 @@ $self->{texts} = {
   'Trans Type'                  => 'Transfertyp',
   'Transaction'                 => 'Buchung',
   'Transaction %d cancelled.'   => 'Buchung %d erfolgreich storniert.',
-  'Transaction Code'            => 'Transaktionscode',
   'Transaction Date missing!'   => 'Buchungsdatum fehlt!',
   'Transaction ID missing.'     => 'Die Buchungs-ID fehlt.',
-  'Transaction Text'            => 'Transaktionstext',
   'Transaction deleted!'        => 'Buchung gelöscht!',
   'Transaction description'     => 'Vorgangsbezeichnung',
   'Transaction has already been cancelled!' => 'Diese Buchung wurde bereits storniert.',