commit ea31457666fa7af01e721ca8c8b7d1c32a8f5b2a
Author: Werner Hahn <wh@futureworldsearch.net>
Date:   Fri Apr 8 12:58:19 2016 +0200

    Shopmodul: ShopParts - Benutzerdefinierte Variablen mit Prefix 'shop_' werden im Reiter Shop Variables angezeigt und im Reiter Benutzerdefinierte Variablen NICHT angezeigt
    
    Conflicts:
            templates/webpages/ic/tabs/_shop.html
    
    Conflicts:
            templates/webpages/ic/tabs/_shop.html
            templates/webpages/shop_part/edit.html

diff --git a/SL/DB/ShopPart.pm b/SL/DB/ShopPart.pm
index 4ac211a90..084b003c6 100644
--- a/SL/DB/ShopPart.pm
+++ b/SL/DB/ShopPart.pm
@@ -4,11 +4,13 @@
 package SL::DB::ShopPart;
 #package SL::DB::ShopPart;
 
+use SL::DB::Helper::AttrHTML;
 use strict;
 
 use SL::DB::MetaSetup::ShopPart;
 use SL::DB::Manager::ShopPart;
 
 __PACKAGE__->meta->initialize;
+__PACKAGE__->attr_html('shop_description');
 
 1;
diff --git a/templates/webpages/ic/tabs/_shop.html b/templates/webpages/ic/tabs/_shop.html
index 3ec640a0d..bb4b16a07 100644
--- a/templates/webpages/ic/tabs/_shop.html
+++ b/templates/webpages/ic/tabs/_shop.html
@@ -1,6 +1,4 @@
-<!-- TMP -->
 [%- USE HTML %][%- USE L -%][%- USE P -%][%- USE LxERP -%]
-<<<<<<< HEAD
 [%- USE Dumper %]
 [%- USE JavaScript -%]
 <div id="shop_variables">
@@ -82,5 +80,64 @@
   </script>
   <div id="shop_images" border=1 >
   </div>
+
+<div id="shop_variables">
+[% LxERP.t8("Active shops:") %]
+ <table>
+  <thead>
+  <tr>
+   <th>[% LxERP.t8("Shop") %]</th>
+   <th>[% LxERP.t8("Active") %]</th>
+   <th>[% LxERP.t8("Shop part") %]</th>
+   <th>[% LxERP.t8("Last update") %]</th>
+   <th>[% LxERP.t8("Action") %]</th>
+   <th>[% LxERP.t8("Action") %]</th>
+  </tr>
+  </thead>
+  [%- FOREACH shop_part = SHOP_PARTS %]
+  <tr>
+   <td>[% HTML.escape( shop_part.shop.description ) %]</td>
+   <td>[% L.html_tag('span', shop_part.active, id => 'shop_part_active_' _ shop_part.id ) %]</td>
+   <td>[% L.html_tag('span', shop_part.shop_description, id => 'shop_part_description_' _ shop_part.id ) %]</td>
+   <td>[% L.html_tag('span', shop_part.last_update.to_kivitendo('precision' => 'minute'), id => 'shop_part_last_update_' _ shop_part.id ) %]</td>
+   <td>[% L.button_tag("kivi.shop_part.edit_shop_part(" _ shop_part.id _ ")", LxERP.t8("Edit"))  %]</td>
+   <td>[% L.button_tag("kivi.shop_part.update_shop_part(" _ shop_part.id _ ")", LxERP.t8("Update"))  %]</td>
+  </tr>
+  [%- END %]
+  [%- FOREACH shop = SHOPS_NOT_ASSIGNED %]
+  <tr>
+   <td>[% HTML.escape( shop.description ) %]</td>
+   <td></td>
+   <td></td>
+   <td></td>
+   <td>[% L.button_tag("kivi.shop_part.create_shop_part(" _ id _ ", " _ shop.id _ ")", LxERP.t8("Add"))  %]</td>
+   <td></td>
+  </tr>
+  [%- END %]
+</table>
+
+
+[% # L.dump(shop_part) %]
+<hr>
+  [%- IF CUSTOM_VARIABLES.size %]
+  <div id="shop_custom_variables">
+   <p>
+    <table>
+     [%- FOREACH var = CUSTOM_VARIABLES %]
+      [%- IF var.name.match('^shop_') %]
+       <tr>
+        [%- IF !var.partsgroup_filtered %]
+          <td align="right" valign="top">[% HTML.escape(var.description) %]</td>
+        [%- END %]
+        <td valign="top">[% var.HTML_CODE %]</td>
+       </tr>
+      [%- END %]
+     [%- END %]
+    </table>
+   </p>
+  </div>
+  [%- END %]
+  <div id="shop_images">
+  </div>
 </div>
 
diff --git a/templates/webpages/shop_part/edit.html b/templates/webpages/shop_part/edit.html
index e823b3a45..fbac62179 100644
--- a/templates/webpages/shop_part/edit.html
+++ b/templates/webpages/shop_part/edit.html
@@ -1,5 +1,8 @@
-<!-- TMP -->
-[%- USE HTML %][%- USE L -%][%- USE P -%][%- USE LxERP -%]
+[%- USE HTML %]
+[%- USE T8 %]
+[%- USE L -%]
+[%- USE P -%]
+[%- USE LxERP -%]
 
 [% LxERP.t8("Part") %]: [% HTML.escape(SELF.shop_part.part.displayable_name) %]<br>
 [% LxERP.t8("Shop") %]: [% HTML.escape(SELF.shop_part.shop.description) %]
@@ -16,7 +19,9 @@
  <table>
   <tr>
    <td>[% LxERP.t8("Description") %]</td>
-   <td>[% L.textarea_tag("shop_part.shop_description", SELF.shop_part.shop_description) %]</td>
+   <td>[% L.textarea_tag('shop_part.shop_description_as_restricted_html', SELF.shop_part.shop_description_as_restricted_html, style='width:100%', rows=20, class="texteditor") %]</td>
+     <td>[% L.textarea_tag('letter.body_as_restricted_html', letter.body_as_restricted_html, style='width:100%', rows=20, class="texteditor") %]</td>
+   <!--   <td>[% L.textarea_tag("shop_part.shop_description", SELF.shop_part.shop_description) %]</td> -->
   </tr>
   <tr>
    <td>[% LxERP.t8("Active") %]</td>