commit 7e6e760547199b6b8ca620e940d8da1684b0b095
Author: Hans Peter Schlaepfer <hanspeter.schlaepfer@revamp-it.ch>
Date:   Fri Jan 4 06:02:01 2019 +0100

    Neues kivitendo Design Aenderungen in templates/webpages/e*
    
    Dateien in email_journal/* employee/*

diff --git a/templates/webpages/email_journal/_filter.html b/templates/webpages/email_journal/_filter.html
index 05a1a75ea..6d8f6407a 100644
--- a/templates/webpages/email_journal/_filter.html
+++ b/templates/webpages/email_journal/_filter.html
@@ -1,41 +1,46 @@
-[%- USE L %][%- USE LxERP %][%- USE HTML %]
-<form action="controller.pl" method="post" id="filter_form">
- <div class="filter_toggle">
-  <a href="#" onClick="javascript:$('.filter_toggle').toggle()">[% LxERP.t8('Show Filter') %]</a>
-  [% IF SELF.filter_summary %]([% LxERP.t8("Current filter") %]: [% SELF.filter_summary %])[% END %]
- </div>
+[% USE L %]
+[% USE LxERP %]
+[% USE HTML %]
 
- <div class="filter_toggle" style="display:none">
-  <a href="#" onClick="javascript:$('.filter_toggle').toggle()">[% LxERP.t8('Hide Filter') %]</a>
-  <table id="filter_table">
-   <tr>
-    <th align="right">[% LxERP.t8("From") %]</th>
-    <td>[% L.input_tag("filter.from:substr::ilike", filter.from_substr__ilike, size = 20) %]</td>
-   </tr>
-   <tr>
-    <th align="right">[% LxERP.t8("Recipients") %]</th>
-    <td>[% L.input_tag("filter.recipients:substr::ilike", filter.recipients_substr__ilike, size = 20) %]</td>
-   </tr>
-   <tr>
-    <th align="right">[% LxERP.t8("Sent on") %]</th>
-    <td>
-     [% L.date_tag("filter.sent_on:date::ge", filter.sent_on_date__ge) %]
-     [% LxERP.t8("To Date") %]
-     [% L.date_tag("filter.sent_on:date::le", filter.sent_on_date__le) %]
-    </td>
-   </tr>
-   <tr>
-    <th align="right">[% LxERP.t8("Status") %]</th>
-    <td>[% L.select_tag("filter.status:eq_ignore_empty", [ [ "", "" ], [ "failed", LxERP.t8("failed") ], [ "ok", LxERP.t8("succeeded") ] ], default=filter.status_eq_ignore_empty) %]</td>
-   </tr>
+[% BLOCK filter_toggle_panel %]
+  <table id="filter_table" class="tbl-horizontal">
+    <tbody>
+    <tr>
+      <th>[% LxERP.t8("From") %]</th>
+      <td>[% L.input_tag("filter.from:substr::ilike", filter.from_substr__ilike, size = 20) %]
+      </td>
+    </tr>
+    <tr>
+      <th>[% LxERP.t8("Recipients") %]</th>
+      <td>[% L.input_tag("filter.recipients:substr::ilike", filter.recipients_substr__ilike, size = 20) %]
+      </td>
+    </tr>
+    <tr>
+      <th>[% LxERP.t8("Sent on") %]</th>
+      <td>[% L.date_tag("filter.sent_on:date::ge", filter.sent_on_date__ge) %] [% LxERP.t8("To Date") %] [% L.date_tag("filter.sent_on:date::le", filter.sent_on_date__le) %]
+      </td>
+    </tr>
+    <tr>
+      <th>[% LxERP.t8("Status") %]</th>
+      <td>[% L.select_tag("filter.status:eq_ignore_empty", [ [ "", "" ], [ "failed", LxERP.t8("failed") ], [ "ok", LxERP.t8("succeeded") ] ], default=filter.status_eq_ignore_empty) %]
+      </td>
+    </tr>
+    </tbody>
   </table>
-
   [% L.hidden_tag("sort_by", FORM.sort_by) %]
   [% L.hidden_tag("sort_dir", FORM.sort_dir) %]
   [% L.hidden_tag("page", FORM.page) %]
+  <div class="buttons">[% L.button_tag('$("#filter_form").resetForm()', LxERP.t8('Reset')) %]</div>
+[% END %]
+
+<div class="wrapper">
+<form action="controller.pl" method="post" id="filter_form">
+
+[% INCLUDE common/toggle_panel.html %]
+
 
-  [% L.button_tag('$("#filter_form").resetForm()', LxERP.t8('Reset')) %]
 
- </div>
+</div>
 
 </form>
+</div>
diff --git a/templates/webpages/email_journal/list.html b/templates/webpages/email_journal/list.html
index f169aed18..514791e80 100644
--- a/templates/webpages/email_journal/list.html
+++ b/templates/webpages/email_journal/list.html
@@ -1,68 +1,48 @@
-[% USE HTML %][% USE L %][% USE LxERP %]
+[% USE HTML %]
+[% USE L %]
+[% USE LxERP %]
 
 <h1>[% FORM.title %]</h1>
 
-[%- INCLUDE 'common/flash.html' %]
-
-[%- PROCESS 'email_journal/_filter.html' filter=SELF.models.filtered.laundered %]
+[% INCLUDE 'common/flash.html' %]
+[% PROCESS 'email_journal/_filter.html' filter=SELF.models.filtered.laundered %]
 
 [% IF !ENTRIES.size %]
- <p>
-  [%- LxERP.t8('There are no entries that match the filter.') %]
- </p>
+  <p>[% LxERP.t8('There are no entries that match the filter.') %]</p>
+
+[% ELSE %]
 
-[%- ELSE %]
- <table id="email_journal_list" width="100%">
+<table id="email_journal_list" class="tbl-list wi-moderate">
   <thead>
-   <tr class="listheading">
-    [% IF SELF.can_view_all %]
-     <th>[% L.sortable_table_header("sender") %]</th>
-    [% END %]
-    <th>[% L.sortable_table_header("from") %]</th>
-    <th>[% L.sortable_table_header("recipients") %]</th>
-    <th>[% L.sortable_table_header("subject") %]</th>
-    <th>[% L.sortable_table_header("sent_on") %]</th>
-    <th>[% L.sortable_table_header("status") %]</th>
-    <th>[% L.sortable_table_header("extended_status") %]</th>
-   </tr>
+    <tr>
+      [% IF SELF.can_view_all %]
+        <th>[% L.sortable_table_header("sender") %]</th>
+      [% END %]
+      <th>[% L.sortable_table_header("from") %]</th>
+      <th>[% L.sortable_table_header("recipients") %]</th>
+      <th>[% L.sortable_table_header("subject") %]</th>
+      <th>[% L.sortable_table_header("sent_on") %]</th>
+      <th>[% L.sortable_table_header("status") %]</th>
+      <th>[% L.sortable_table_header("extended_status") %]</th>
+    </tr>
   </thead>
-
   <tbody>
-  [%- FOREACH entry = ENTRIES %]
-  <tr class="listrow[% IF entry.status != 'ok' %]_error[% END %]" id="email_journal_id_[% entry.id %]">
-   [% IF SELF.can_view_all %]
-    <td>
-     [% IF entry.sender %]
-      [% HTML.escape(entry.sender.name) %]
-     [% ELSE %]
-      [% LxERP.t8("kivitendo") %]
-     [% END %]
-    </td>
-   [% END %]
-   <td>
-    <a href="[% SELF.url_for(action => 'show', id => entry.id, back_to => SELF.get_callback) %]">
-     [%- HTML.escape(entry.from) %]
-    </a>
-   </td>
-   <td>[%- HTML.escape(entry.recipients) %]</td>
-   <td>
-    <a href="[% SELF.url_for(action => 'show', id => entry.id, back_to => SELF.get_callback) %]">
-     [%- HTML.escape(entry.subject) %]
-    </a>
-   </td>
-   <td>[%- HTML.escape(entry.sent_on.to_lxoffice('precision' => 'second')) %]</td>
-   <td>
-    [%- IF entry.status == 'ok' %]
-     [%- LxERP.t8('succeeded') %]
-    [% ELSE %]
-     [%- LxERP.t8('failed') %]
-    [%- END %]
-   </td>
-   <td>[%- HTML.escape(entry.extended_status) %]</td>
-  </tr>
-  [%- END %]
+    [% FOREACH entry = ENTRIES %]
+    <tr[% IF entry.status != 'ok' %] class="row_error[% END %]" id="email_journal_id_[% entry.id %]">
+      [% IF SELF.can_view_all %]
+        <td>[% IF entry.sender %] [% HTML.escape(entry.sender.name) %] [% ELSE %] [% LxERP.t8("kivitendo") %] [% END %]</td>
+      [% END %]
+      <td><a href="[% SELF.url_for(action => 'show', id => entry.id, back_to => SELF.get_callback) %]"> [% HTML.escape(entry.from) %] </a></td>
+      <td>[% HTML.escape(entry.recipients) %]</td>
+      <td><a href="[% SELF.url_for(action => 'show', id => entry.id, back_to => SELF.get_callback) %]"> [% HTML.escape(entry.subject) %] </a></td>
+      <td>[% HTML.escape(entry.sent_on.to_lxoffice('precision' => 'second')) %]</td>
+      <td>[% IF entry.status == 'ok' %] [% LxERP.t8('succeeded') %] [% ELSE %] [% LxERP.t8('failed') %] [% END %]</td>
+      <td>[% HTML.escape(entry.extended_status) %]</td>
+    </tr>
+    [% END %]
   </tbody>
- </table>
-[%- END %]
+</table>
+
+[% END %]
 
 [% L.paginate_controls %]
diff --git a/templates/webpages/email_journal/show.html b/templates/webpages/email_journal/show.html
index 20444a9c8..900d08764 100644
--- a/templates/webpages/email_journal/show.html
+++ b/templates/webpages/email_journal/show.html
@@ -1,79 +1,71 @@
-[% USE HTML %][% USE L %][% USE LxERP %]
+[% USE HTML %]
+[% USE L %]
+[% USE LxERP %]
 
- <h1>[% FORM.title %]</h1>
+<h1>[% FORM.title %]</h1>
 
-[%- INCLUDE 'common/flash.html' %]
+[% INCLUDE 'common/flash.html' %]
 
- <table id="email_journal_details" class="email_journal_details">
-  <tbody>
-   <tr class="listrow">
-    <th>[%- LxERP.t8("From") %]</th>
-    <td>[%- HTML.escape(SELF.entry.from) %]</td>
-   </tr>
-
-   <tr class="listrow">
-    <th>[%- LxERP.t8("Recipients") %]</th>
-    <td>[%- HTML.escape(SELF.entry.recipients) %]</td>
-   </tr>
-
-   <tr class="listrow">
-    <th>[%- LxERP.t8("Subject") %]</th>
-    <td>[%- HTML.escape(SELF.entry.subject) %]</td>
-   </tr>
-
-   <tr class="listrow">
-    <th>[%- LxERP.t8("Sent on") %]</th>
-    <td>[%- HTML.escape(SELF.entry.sent_on.to_lxoffice("precision" => "second")) %]</td>
-   </tr>
 
-   <tr class="listrow">
-    <th>[%- LxERP.t8("Status") %]</th>
-    <td>
-     [%- IF SELF.entry.status == "ok" %]
-      [%- LxERP.t8("succeeded") %]
-     [%- ELSE %]
-      [%- LxERP.t8("failed") %]
-     [%- END %]
-    </td>
-   </tr>
-
-   <tr class="listrow">
-    <th>[%- LxERP.t8("Extended status") %]</th>
-    <td><pre>[%- HTML.escape(SELF.entry.extended_status) %]</pre></td>
-   </tr>
-
-   <tr class="listrow">
-    <th>[%- LxERP.t8("Headers") %]</th>
-    <td><pre>[% HTML.escape(SELF.entry.headers) %]</pre></td>
-   </tr>
+<table id="email_journal_details" class="tbl-horizontal email_journal_details">
+  <tbody>
+    <tr>
+      <th>[% LxERP.t8("From") %]</th>
+      <td>[% HTML.escape(SELF.entry.from) %]</td>
+    </tr>
+    <tr>
+      <th>[% LxERP.t8("Recipients") %]</th>
+      <td>[% HTML.escape(SELF.entry.recipients) %]</td>
+    </tr>
+    <tr>
+      <th>[% LxERP.t8("Subject") %]</th>
+      <td>[% HTML.escape(SELF.entry.subject) %]</td>
+    </tr>
+    <tr>
+      <th>[% LxERP.t8("Sent on") %]</th>
+      <td>[% HTML.escape(SELF.entry.sent_on.to_lxoffice("precision" => "second")) %]</td>
+    </tr>
+    <tr>
+      <th>[% LxERP.t8("Status") %]</th>
+      <td> [% IF SELF.entry.status == "ok" %] [% LxERP.t8("succeeded") %] [% ELSE %] [% LxERP.t8("failed") %] [% END %]</td>
+    </tr>
+    <tr>
+      <th>[% LxERP.t8("Extended status") %]</th>
+      <td><pre>[% HTML.escape(SELF.entry.extended_status) %]</pre></td>
+    </tr>
+    <tr>
+      <th>[% LxERP.t8("Headers") %]</th>
+      <td><pre>[% HTML.escape(SELF.entry.headers) %]</pre></td>
+    </tr>
+    <tr>
+      <th>[% LxERP.t8("Body") %]</th>
+      <td><pre>[% HTML.escape(SELF.entry.body) %]</pre></td>
+    </tr>
+  </tbody>
+</table>
 
-   <tr class="listrow">
-    <th>[%- LxERP.t8("Body") %]</th>
-    <td><pre>[% HTML.escape(SELF.entry.body) %]</pre></td>
-   </tr>
- </table>
 
- [% SET attachments = SELF.entry.attachments_sorted %]
- [% IF attachments.size %]
-  <h2>[% LxERP.t8("Attachments") %]</h2>
+[% SET attachments = SELF.entry.attachments_sorted %]
+[% IF attachments.size %]
 
-  <table id="email_journal_details" class="email_journal_details">
-   <thead>
+<table id="email_journal_details" class="tbl-list email_journal_details">
+  <caption>[% LxERP.t8("Attachments") %]</caption>
+  <thead>
     <tr>
-     <th>[% LxERP.t8("Attachment name") %]</th>
-     <th>[% LxERP.t8("MIME type") %]</th>
-     <th>[% LxERP.t8("Size") %]</th>
+      <th>[% LxERP.t8("Attachment name") %]</th>
+      <th>[% LxERP.t8("MIME type") %]</th>
+      <th>[% LxERP.t8("Size") %]</th>
     </tr>
-   </thead>
-
-   <tbody>
+  </thead>
+  <tbody>
     [% FOREACH attachment = attachments %]
-     <tr class="listrow">
+    <tr>
       <td>[% L.link(SELF.url_for(action="download_attachment", id=attachment.id), attachment.name) %]</td>
       <td>[% HTML.escape(attachment.mime_type) %]</td>
       <td>[% HTML.escape(LxERP.format_amount(attachment.content.length, 0)) %]</td>
-     </tr>
+    </tr>
     [% END %]
-   </tbody>
-  </table>
- [% END %]
+  </tbody>
+</table>
+
+[% END %]
diff --git a/templates/webpages/employee/_list.html b/templates/webpages/employee/_list.html
index 5c92d44e8..58a1aab43 100644
--- a/templates/webpages/employee/_list.html
+++ b/templates/webpages/employee/_list.html
@@ -1,15 +1,15 @@
-[%- USE T8 %]
+[% USE T8 %]
 <table>
- <tr class='listheading'>
+ <tr>
   <th>[% 'Login of User' | $T8 %]</th>
   <th>[% 'Name' | $T8 %]</th>
   <th>[% 'Deleted' | $T8 %]</th>
  </tr>
-[%- FOREACH row IN SELF.employees %]
+[% FOREACH row IN SELF.employees %]
  <tr class='listrow[% loop.count % 2 %]'>
   <td><a href='[% SELF.url_for(action="edit", "employee.id"=row.id) %]'>[% row.login | html %]</a></td>
   <td>[% row.name | html %]</td>
   <td>[% row.deleted_as_bool_yn | html %]</td>
  </tr>
-[%- END %]
+[% END %]
  </table>